/*
Example user code that calls the "oslevent" library.
Orion Sky Lawlor, olawlor@acm.org, 2005/1/28 (Public Domain)
*/
#include <stdio.h> /* for printf */
#include "oslevent.h"
oslevent_pool *oslevent; /* library interface object (doesn't have to be global) */

class sequencer : public oslevent_class {
public:
	const char *what; /* what we're doing */
	int i, n; /* current step, and number of steps */
	sequencer(const char *what_,int n_) {what=what_; i=0; n=n_;}

	virtual void execute(void) {
		i++;
		printf("%s: step %d of %d\n",what,i,n); /* or real code here... */
		if (i==5) oslevent->add(new sequencer("late",4)); /* create new task */
		if (i<n) oslevent->add(this); /* ask for another execution */
	}
};

int main() {
	oslevent=new oslevent_pool; /* initialize library */
	sequencer s1("foo",6), s2("bar",3);
	oslevent->add(&s1); /* will run s1.execute() once during loop */
	oslevent->add(&s2); /* will run s2.execute() once during loop */
	oslevent->loop(); /* keep processing events until there are no more */
}
